/**
** This software is distributed under the terms of the General Public License.  
** 
** Program : BuildIT!
** Version : 0.2
** Authors : Artur Prusakiewicz <prusak@mat.uni.torun.pl>
**	     Michal Switala <scisly@mat.uni.torun.pl>
** E-MAIL  : build@mat.uni.torun.pl
** WWW     : http://www.mat.uni.torun.pl/~scisly/buildit/
**           http://www.mat.uni.torun.pl/~prusak/buildit/
**/
#include <qscrbar.h>
#include <qlist.h>
#include <qstring.h>

#ifndef _PROPS
Q_DECLARE(QListM,QString);
#endif

class MyScrollBar:public QScrollBar
{
  Q_OBJECT
public:
  MyScrollBar(QWidget * parent=0,const char * name=0);
  void setId(QString value){id=value;};
  QString getId(){return id;}
  void setVal(int value){vl=value;}
  int getVal(){return vl;}  
  void setMax(int value){max=value;}
  int getMax(){return max;}  
  void setMin(int value){min=value;}
  int getMin(){return min;}    
  void setPS(int value){page_size=value;}
  int getPS(){return page_size;}  
  QListM(QString) evt;
 public slots:
 void semOp();
 void semDown();
signals:
  void mv(QWidget *widget,QMouseEvent *event);
  void press(QWidget *widget,QMouseEvent *event);
  void release(QWidget *widget,QMouseEvent *event);
  void dbclick(QWidget *widget,QMouseEvent *event);
  void touch(QWidget *widget);
  void noEnter();
  void leave();
private:
  bool sem;
  int click;
  QString id;
  int vl,max,min,page_size;
  void mouseMoveEvent(QMouseEvent *event){emit touch(this);emit mv(this,event);}
  void mousePressEvent(QMouseEvent *event){emit touch(this);emit press(this,event);}  
  void mouseReleaseEvent(QMouseEvent *event){emit touch(this);emit release(this,event);}
  void mouseDoubleClickEvent(QMouseEvent *event){emit touch(this);emit dbclick(this,event);}
  void leaveEvent(QEvent *event){emit leave();}
};






